//
// Created by zoe on 12/20/22.
//

#ifndef HOST_CENTRAL_MAST_CONNECTIONMANAGER_H
#define HOST_CENTRAL_MAST_CONNECTIONMANAGER_H

#define TINY_GSM_MODEM_SIM7000

#include "GPRSCredentials.h"
#include "Mode.h"
#include "ModemFunctionalityLevel.h"
#include "NetworkMode.h"
#include "RequestInformation.h"
#include "StreamDebugger.h"
#include <TinyGsmClient.h>

static const std::string TAG_GSM = "GSM";

class ConnectionManager {
  private:
    TinyGsm &modem;
    const GPRSCredentials credentials;

  public:
    ConnectionManager(TinyGsm &client, GPRSCredentials credentials);

    std::string connect(const std::string &host, int port, RequestInformation requestInformation);

    void enableGPS();

    void disableGPS();

    void initModem();

    void restartModem();

    void setNetworkMode(NetworkMode networkMode = NetworkMode::LTE_ONLY);

    void setPreferredMode(Mode mode = Mode::CAT_M);

    void setModemFunctionalityLevel(ModemFunctionalityLevel functionalityLevel = MINIMAL);

    enum BandMode { BAND_CAT_M, BAND_NB_IoT };

    void setBand(BandMode bandMode, int band);

    bool gprsConnect();

    bool isNetworkConnected();
};

#endif // HOST_CENTRAL_MAST_CONNECTIONMANAGER_H
