//
// Created by zoe on 12/19/22.
//

#ifndef HOST_CENTRAL_MAST_STRINGTOTIMECONVERSIONEXCEPTION_HPP
#define HOST_CENTRAL_MAST_STRINGTOTIMECONVERSIONEXCEPTION_HPP

#include <exception>
#include <string>
#include "TimeManager.h"

class StringToTimeConversionException : public std::exception {
public:
    explicit StringToTimeConversionException(const std::string &message) : message(message) {}

    const char *what() const noexcept override {
        esp_log_write(ESP_LOG_ERROR, "TimeManager", "Error converting time to epoch: %s",
                      message.c_str());
        return message.c_str();
    }

private:
    std::string message;
};

#endif //HOST_CENTRAL_MAST_STRINGTOTIMECONVERSIONEXCEPTION_HPP
