//
// Created by zoe on 12/19/22.
//

#ifndef HOST_CENTRAL_MAST_TIMEMANAGER_H
#define HOST_CENTRAL_MAST_TIMEMANAGER_H

#define TINY_GSM_MODEM_SIM7000

#include "ESP32Time.h"
#include "NTPException.hpp"
#include "StringToTimeConversionException.hpp"
#include <TinyGsmClientSIM7000.h>
#include <iomanip>
#include <string>

class TimeManager {
  public:
    explicit TimeManager(TinyGsmSim7000 &modem);

  private:
    constexpr static char *TAG = "TimeManager";
    ESP32Time rtc;
    int timeZone = 0;

    // I would like this to be a const reference but the functions used by the modem are not const
    TinyGsmSim7000 &modem;

    // sync ntp
    void syncNTP(const std::string &ntpServer = "time1.uibk.ac.at");

    // convert time to unix epoch seconds
    static time_t timeToUnixEpochSeconds(const std::string &time, const std::string &format = "%y/%m/%d,%H:%M:%S%z");

    // write modem time to rtc
    void writeModemTimeToRTC();
};

#endif // HOST_CENTRAL_MAST_TIMEMANAGER_H