///**************************************************************
// *
// * This sketch connects to a website and downloads a page.
// * It can be used to perform HTTP/RESTful API calls.
// *
// * TinyGSM Getting Started guide:
// *   https://tiny.cc/tinygsm-readme
// *
// **************************************************************/
//
//// Select your modem:
//// #define TINY_GSM_MODEM_SIM800
//// #define TINY_GSM_MODEM_SIM808
//// #define TINY_GSM_MODEM_SIM868
//// #define TINY_GSM_MODEM_SIM900
//#define TINY_GSM_MODEM_SIM7000
//// #define TINY_GSM_MODEM_SIM7000SSL
//// #define TINY_GSM_MODEM_SIM7080
//// #define TINY_GSM_MODEM_SIM5360
//// #define TINY_GSM_MODEM_SIM7600
//// #define TINY_GSM_MODEM_UBLOX
//// #define TINY_GSM_MODEM_SARAR4
//// #define TINY_GSM_MODEM_M95
//// #define TINY_GSM_MODEM_BG96
//// #define TINY_GSM_MODEM_A6
//// #define TINY_GSM_MODEM_A7
//// #define TINY_GSM_MODEM_M590
//// #define TINY_GSM_MODEM_MC60
//// #define TINY_GSM_MODEM_MC60E
//// #define TINY_GSM_MODEM_ESP8266
//// #define TINY_GSM_MODEM_XBEE
//// #define TINY_GSM_MODEM_SEQUANS_MONARCH
//
//// Set serial for debug console (to the Serial Monitor, default speed 115200)
//#define SerialMon Serial
//
//// Set serial for AT commands (to the module)
//// Use Hardware Serial on Mega, Leonardo, Micro
//#ifndef __AVR_ATmega328P__
//#define SerialAT Serial1
//
//// or Software Serial on Uno, Nano
//#else
//#include <SoftwareSerial.h>
//SoftwareSerial SerialAT(2, 3); // RX, TX
//#endif
//
//// Increase RX buffer to capture the entire response
//// Chips without internal buffering (A6/A7, ESP8266, M590)
//// need enough space in the buffer for the entire response
//// else data will be lost (and the http library will fail).
//#if !defined(TINY_GSM_RX_BUFFER)
//#define TINY_GSM_RX_BUFFER 650
//#endif
//
//// See all AT commands, if wanted
//#define DUMP_AT_COMMANDS
//
//// Define the serial console for debug prints, if needed
//#define TINY_GSM_DEBUG SerialMon
//
//// Range to attempt to autobaud
//// NOTE:  DO NOT AUTOBAUD in production code.  Once you've established
//// communication, set a fixed baud rate using modem.setBaud(#).
//#define GSM_AUTOBAUD_MIN 9600
//#define GSM_AUTOBAUD_MAX 115200
//
//// Add a reception delay, if needed.
//// This may be needed for a fast processor at a slow baud rate.
//// #define TINY_GSM_YIELD() { delay(2); }
//
//// Uncomment this if you want to use SSL
//// #define USE_SSL
//
//// Define how you're planning to connect to the internet.
//// This is only needed for this example, not in other code.
//#define TINY_GSM_USE_GPRS true
//#define TINY_GSM_USE_WIFI false
//
//// set GSM PIN, if any
//#define GSM_PIN ""
//
//// Your GPRS credentials, if any
//const char apn[] = "m2m.public.at";
//const char gprsUser[] = "";
//const char gprsPass[] = "";
//
//// Your WiFi connection credentials, if applicable
//const char wifiSSID[] = "YourSSID";
//const char wifiPass[] = "YourWiFiPass";
//
//// Server details
//const char server[] = "vsh.pp.ua";
//const char resource[] = "/TinyGSM/logo.txt";
//
//#include <TinyGsmClient.h>
//#include <WiFi.h>
//#include <esp_now.h>
//
//// Just in case someone defined the wrong thing..
//#if TINY_GSM_USE_GPRS && not defined TINY_GSM_MODEM_HAS_GPRS
//#undef TINY_GSM_USE_GPRS
//#undef TINY_GSM_USE_WIFI
//#define TINY_GSM_USE_GPRS false
//#define TINY_GSM_USE_WIFI true
//#endif
//#if TINY_GSM_USE_WIFI && not defined TINY_GSM_MODEM_HAS_WIFI
//#undef TINY_GSM_USE_GPRS
//#undef TINY_GSM_USE_WIFI
//#define TINY_GSM_USE_GPRS true
//#define TINY_GSM_USE_WIFI false
//#endif
//
//#ifdef DUMP_AT_COMMANDS
//#include <StreamDebugger.h>
//StreamDebugger debugger(SerialAT, SerialMon);
//TinyGsm modem(debugger);
//#else
//TinyGsm modem(SerialAT);
//#endif
//
//#ifdef USE_SSL
//TinyGsmClientSecure client_satellite(modem);
//const int port = 443;
//#else
//TinyGsmClient client_satellite(modem);
//const int port = 80;
//#endif
//
//TaskHandle_t Task1;
//
//void on_data_sent(const uint8_t *mac_addr, esp_now_send_status_t status)
//{
//	// go to sleep
//}
//
//void on_data_recv(const uint8_t *mac, const uint8_t *incomingData, int len)
//{
//	// print mac
//	Serial.print("Message recieved: Core ");
//	Serial.println(xPortGetCoreID());
//	for (int i = 0; i < 6; i++) {
//		Serial.print(mac[i], HEX);
//		Serial.print(":");
//	}
//	Serial.println();
//	char data[len];
//	memcpy(data, incomingData, len);
//	Serial.println(data);
//}
//
//[[noreturn]] void Task1code(void *parameter)
//{
//	Serial.println(xPortGetCoreID());
//	WiFi.mode(WIFI_STA);
//	Serial.println("ESPNow init");
//	if (esp_now_init() != ESP_OK) {
//		// initialization failed
//		Serial.println("ESPNow init failed");
//		// not sure about this
//	}
//	Serial.println("ESPNow init success");
//	esp_now_register_recv_cb(on_data_recv);
//
//	while (true) {
//	}
//}
//
//void setup2()
//{
//	// Set console baud rate
//	SerialMon.begin(115200);
//	delay(10);
//
//	// !!!!!!!!!!!
//	// Set your reset, enable, power pins here
//	// !!!!!!!!!!!
//
//	SerialMon.println("Wait...");
//
//	xTaskCreatePinnedToCore(Task1code, /* Function to implement the task */
//	                        "Task1",   /* Name of the task */
//	                        10000,     /* Stack size in words */
//	                        nullptr,   /* Task input parameter */
//	                        0,         /* Priority of the task */
//	                        &Task1,    /* Task handle. */
//	                        0);        /* Core where the task should run */
//
//	// Set GSM module baud rate
//	//	TinyGsmAutoBaud(SerialAT, GSM_AUTOBAUD_MIN, GSM_AUTOBAUD_MAX);
//	modem.setBaud(9600);
//	// SerialAT.begin(9600);
//	delay(6000);
//
//	// Restart takes quite some time
//	// To skip it, call init() instead of restart()
//	SerialMon.println("Initializing modem...");
//	modem.restart();
//	// modem.init();
//
//	String modemInfo = modem.getModemInfo();
//	SerialMon.print("Modem Info: ");
//	SerialMon.println(modemInfo);
//
//#if TINY_GSM_USE_GPRS
//	// Unlock your SIM card with a PIN if needed
//	if (GSM_PIN && modem.getSimStatus() != 3) {
//		modem.simUnlock(GSM_PIN);
//	}
//#endif
//}
//
//void loop2()
//{
//#if TINY_GSM_USE_WIFI
//	// Wifi connection parameters must be set before waiting for the network
//	SerialMon.print(F("Setting SSID/password..."));
//	if (!modem.networkConnect(wifiSSID, wifiPass)) {
//		SerialMon.println(" fail");
//		delay(10000);
//		return;
//	}
//	SerialMon.println(" success");
//#endif
//
//#if TINY_GSM_USE_GPRS && defined TINY_GSM_MODEM_XBEE
//	// The XBee must run the gprsConnect function BEFORE waiting for network!
//	modem.gprsConnect(apn, gprsUser, gprsPass);
//#endif
//
//	SerialMon.print("Waiting for network...");
//	if (!modem.waitForNetwork()) {
//		SerialMon.println(" fail");
//		delay(10000);
//		return;
//	}
//	SerialMon.println(" success");
//
//	if (modem.isNetworkConnected()) {
//		SerialMon.println("Network connected");
//	}
//
//#if TINY_GSM_USE_GPRS
//	// GPRS connection parameters are usually set after network registration
//	SerialMon.print(F("Connecting to "));
//	SerialMon.print(apn);
//	if (!modem.gprsConnect(apn, gprsUser, gprsPass)) {
//		SerialMon.println(" fail");
//		delay(10000);
//		return;
//	}
//	SerialMon.println(" success");
//
//	if (modem.isGprsConnected()) {
//		SerialMon.println("GPRS connected");
//	}
//#endif
//
//	SerialMon.print("Connecting to ");
//	SerialMon.println(server);
//	if (!client_satellite.connect(server, port)) {
//		SerialMon.println(" fail");
//		delay(10000);
//		return;
//	}
//	SerialMon.println(" success");
//
//	// Make a HTTP GET request:
//	SerialMon.println("Performing HTTP GET request...");
//	client_satellite.print(String("GET ") + resource + " HTTP/1.1\r\n");
//	client_satellite.print(String("Host: ") + server + "\r\n");
//	client_satellite.print("Connection: close\r\n\r\n");
//	client_satellite.println();
//
//	uint32_t timeout = millis();
//	while (client_satellite.connected() && millis() - timeout < 10000L) {
//		// Print available data
//		while (client_satellite.available()) {
//			char c = client_satellite.read();
//			SerialMon.print(c);
//			timeout = millis();
//		}
//	}
//	SerialMon.println();
//
//	// Shutdown
//
//	client_satellite.stop();
//	SerialMon.println(F("Server disconnected"));
//
//#if TINY_GSM_USE_WIFI
//	modem.networkDisconnect();
//	SerialMon.println(F("WiFi disconnected"));
//#endif
//#if TINY_GSM_USE_GPRS
//	modem.gprsDisconnect();
//	SerialMon.println(F("GPRS disconnected"));
//#endif
//
//	// Do nothing forevermore
//	while (true) {
//		delay(1000);
//	}
//}
